package system

import "github.com/shirou/gopsutil/process"

func (i *InfoUtils) GetAllProcessPid() []int32 {
	pidList, _ := process.Pids()
	return pidList
}

func (i *InfoUtils) GetProcessInfo(pid int32) *process.Process {
	info, _ := process.NewProcess(pid)
	return info
}

type ProcessDTO struct {
	Pid        int32            `json:"pid"`
	Name       string           `json:"name"`
	Parent     *process.Process `json:"parent"`
	Status     string           `json:"status"`
	CreateTime int64            `json:"createTime"`
}

func (i *InfoUtils) GetProcesses() []*ProcessDTO {
	info, _ := process.Processes()
	dto := make([]*ProcessDTO, 0)
	for _, i := range info {
		d := &ProcessDTO{
			Pid:        i.Pid,
			Name:       "",
			Parent:     nil,
			Status:     "",
			CreateTime: 0,
		}

		d.Name, _ = i.Name()
		d.Parent, _ = i.Parent()
		d.CreateTime, _ = i.CreateTime()
		d.Status, _ = i.Status()

		dto = append(dto, d)
	}
	return dto
}
